<?php 
/* 
   Plugin Name: ytlink 
   Plugin URI: http://linux.wordpress.at 
   Description: Erzeugt einen Link mit Vorschaubild aus einem Shortcode nur mit der Video-ID für Youtube 
   Version: 0.3
   Author: Jakobus Schürz 
   Author URI: http://www.xundeenergie.at

   This program is distributed under the GNU General Public License, Version 2, 
   June 1991. Copyright (C) 1989, 1991 Free Software Foundation, Inc., 51 Franklin 
   St, Fifth Floor, Boston, MA 02110, USA 

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
   ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
   ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/ 

define( 'YTLINK_VERSION', '0.1' );
define( 'YTLINK_URL', plugin_dir_url(__FILE__) );
if (!defined('WP_CONTENT_URL'))
      define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
if (!defined('WP_CONTENT_DIR'))
      define('WP_CONTENT_DIR', ABSPATH.'wp-content');
if (!defined('WP_PLUGIN_URL'))
      define('WP_PLUGIN_URL', WP_CONTENT_URL.'/plugins');
if (!defined('WP_PLUGIN_DIR'))
      define('WP_PLUGIN_DIR', WP_CONTENT_DIR.'/plugins');

function activate_ytlink() {
  add_option('videobox', 'prettyphoto');
  add_option('ico_x', '220');
  add_option('ico_xs', '120');
  add_option('ico_xm', '220');
  add_option('ico_xl', '340');
  add_option('ico_y', '130');
  add_option('fs', 'true');
  add_option('fo', 'v');
  add_option('ppic', 'default');
  add_option('video_x', '800');
  add_option('video_y', '600');
  add_option('tit', 'Video ansehen');
  add_option('video_x_def', '800');
  add_option('video_y_def', '600');
  add_option('tit_def', 'Video ansehen');
  add_option('fsli', 'filmstreifen-links.png');
  add_option('fsre', 'filmstreifen-rechts.png');
  add_option('fsob', 'filmstreifen-oben.png');
  add_option('fsun', 'filmstreifen-unten.png');
}

function defaults_ytlink() {
  update_option('videobox', 'prettyphoto');
  update_option('ico_x', '220');
  update_option('ico_xs', '120');
  update_option('ico_xm', '220');
  update_option('ico_xl', '340');
  update_option('ico_y', '130');
  update_option('fs', 'true');
  update_option('fso', 'v');
  update_option('video_x', '800');
  update_option('video_y', '600');
  update_option('tit', 'Video ansehen');
  update_option('video_x_def', '800');
  update_option('video_y_def', '600');
  update_option('tit_def', 'Video aluaga');
}

function deactive_ytlink() {
  delete_option('videobox');
  delete_option('ico_x');
  delete_option('ico_xs');
  delete_option('ico_xm');
  delete_option('ico_xl');
  delete_option('ico_y');
  delete_option('ppic');
  delete_option('fs');
  delete_option('fso');
  delete_option('fsli');
  delete_option('fsre');
  delete_option('fsob');
  delete_option('fsun');
  delete_option('video_x');
  delete_option('video_y');
  delete_option('tit');
  delete_option('video_x_def');
  delete_option('video_y_def');
  delete_option('tit_def');
}

function admin_init_ytlink() {
  register_setting('ytlink', 'videobox');
  register_setting('ytlink', 'ico_x');
  register_setting('ytlink', 'ico_xs');
  register_setting('ytlink', 'ico_xm');
  register_setting('ytlink', 'ico_xl');
  register_setting('ytlink', 'ico_y');
  register_setting('ytlink', 'ppic');
  register_setting('ytlink', 'video_x');
  register_setting('ytlink', 'video_y');
  register_setting('ytlink', 'tit');
  register_setting('ytlink', 'video_x_def');
  register_setting('ytlink', 'video_y_def');
  register_setting('ytlink', 'tit_def');
  register_setting('ytlink', 'fs');
  register_setting('ytlink', 'fso');
  register_setting('ytlink', 'fsli');
  register_setting('ytlink', 'fsre');
  register_setting('ytlink', 'fsob');
  register_setting('ytlink', 'fun');
}

function admin_menu_ytlink() {
  add_options_page('Youtube-Link', 'Youtube-Link', 'manage_options', 'ytlink', 'options_page_youtubelink');
}

function options_page_youtubelink() {
  include(WP_PLUGIN_DIR.'/ytlink/options.php');  
}

if (is_admin()) {
  add_action('admin_init', 'admin_init_ytlink');
  add_action('admin_menu', 'admin_menu_ytlink');
}



function ytlink_func($atts) {

  $videobox = get_option('videobox');
  $ico_x = get_option('ico_x');
  $ico_y = floor(get_option('ico_x')*3/4);
  $param = get_option('param');
  $size = "";
  $rz = rand(100, 999);
/**
  update_option('video_x', get_option('video_x_def'));
  update_option('video_y', get_option('video_y_def'));
  update_option('tit', get_option('tit_def'));
  $x = get_option('video_x');
  $y = get_option('video_y');
  $tit = get_option('tit');
*/

  // liest die im Shortcode angegebenen parameter aus.
  extract(shortcode_atts(array(  
   'ytid' => '', 'tit' => '', 'x' => '', 'y' => '', 'ppic' => '', 'fso' => ''
   ), $atts));

  if ( $x == '' ) $video_x = get_option('video_x'); else $video_x = $x;
  if ( $y == '' ) $video_y = get_option('video_y'); else $video_y = $y;
  if ( $ppic == '' ) $ppic = get_option('ppic');
  if ( $tit == '' ) $tit = get_option('tit');
  if ( $fso == '' ) $fso = get_option('fso');


  switch ($videobox)
  {
  case "fancybox":
     $param = "id='youtube_fancybox_" . $ytid . "-" . $rz . "'";
     break;
  case "prettyphoto":
     $param = "id='youtube_prettyphoto_" . $ytid . "-" . $rz . "'";
     break;
  default:
     $param = "target='_blank'";
  }

  if ($video_x != "" && $video_y != "") $size = "&width=" . $video_x . "&height=" . $video_y;  
/*********************************************/
/** Dieses Java-Script muss an dieser Stelle in den Body eingefügt werden, da es im Header zu früh geladen wird und die Variablen "video_x" und video_y" noch nicht initialisiert sind vom plugin. Die Klasse wird für jedes Video extra festgelegt, damit der fancybox-Aufruf für ev. verschiedene Größenangaben individualisiert ist!!! **/

?>
<!-- START ytlink -->
<script type="text/javascript">
jQuery(function(){
<?php
  if(get_option('videobox') == 'fancybox') {
?>
//jQuery-fancybox
jQuery("#youtube_fancybox_<?php echo $ytid . "-" . $rz; ?>").click(function() {
jQuery.fancybox({
        'padding'       : 6,
//        'autoScale'     : false,
        'transitionIn'  : 'elastic',
        'transitionOut' : 'elastic',
	'width'		: '<?php echo $video_x; ?>',
	'height'	: '<?php echo $video_y; ?>',
        'speedIn': 500,
        'speedOut': 500,
        'title'         : this.title,
        'titlePosition'   : 'inside',
        'easingIn'   : 'easeOutBack',
        'easingOut'   : 'easeInOutElastic',
        'href'          : this.href.replace(new RegExp("watch\\?v=", "i"), 'v/')+ '&autoplay=1',
        'type'          : 'swf',
        'swf'           : {
             'wmode'        : 'transparent',
            'allowfullscreen'   : 'true'
        }
    });

return false;


});

<?php 
  } 

  if(get_option('videobox') == 'prettyphoto') {
?>
//jQuery-prettyphoto
jQuery("#youtube_prettyphoto_<?php echo $ytid . "-" . $rz; ?>").prettyPhoto({});

<?php
  }
?>
})
</script>
<!-- END ytlink -->
<?php


/**********************************************/

//Festlegen des Codes für das Video ($vlink) und des Vorschaubildes ($ilink)

  $vlink="http://www.youtube.com/watch?v=" . $ytid;
  $ilink="http://i.ytimg.com/vi/" . $ytid . "/" . $ppic . ".jpg";
  $imgurl=WP_PLUGIN_URL . "/ytlink/images/";
  $overlayimg=$imgurl . "video-button-transp.png";

  if ( get_option('fs') == true) {
    if ( $fso == 'h') {
      $fsl = $imgurl . get_option('fsob');
      $fsr = $imgurl . get_option('fsun');
      $fssize = getimagesize($fsl);
      $bgrep = "repeat-x";
      $fswidth =  get_option('ico_x') . "px";
      $fsheight =  $fssize[1] . "px";
      $fspad_x = "0px";
      $fspad_y = $fsheight;
     $floatprev = "clear:left";
      $floatoben = "left";
//      $floatprev = "left";
      $floatunten = "left";
      $ppic_x = $ico_x + ( 2 * $fspad_x);
      $ppic_y = $ico_y + ( 2 * $fspad_y);

    } else {

      $fsl = $imgurl . get_option('fsli');
      $fsr = $imgurl . get_option('fsre');
      $fssize = getimagesize($fsl);
      $bgrep = "repeat-y";
      $fsheight =  floor(get_option('ico_x')*3/4) . "px";
      $fswidth =  $fssize[0] . "px";
      $fspad_x = $fswidth;
      $fspad_y = "0px";
      $floatprev = "float:left";
      $floatoben = "left";
//      $floatprev = "left";
      $floatunten = "right";
      $ppic_x = $ico_x + ( 2 * $fspad_x);
      $ppic_y = $ico_y + ( 2 * $fspad_y);

    }
  }


$output = "
<!-- Festlegen des Stylesheets für die Ausgabe -->

<style type='text/css'>
div.ppic_" . $ytid . "-" . $rz . " {
  width:" . $ppic_x . "px;
  margin:0;
  text-align:center;
}


div.ppr_" . $ytid . "-" . $rz . " {
  width:" . $ppic_x . "px;
  height:" . $ppic_y . "px;
  margin:0 auto;
  text-align:left;
}

div.pic_" . $ytid . "-" . $rz . " {
  width:" . $ico_x . "px;
  height:" . $ico_y . "px;
  " . $floatprev . ";
  background-image:url('" . $ilink . "');
  background-repeat: no-repeat;
  background-size: contain;
}

img.pic_" . $ytid . "-" . $rz . " {
  width:" . $ico_x . "px;
  height:" . $ico_y . "px;
  filter:alpha(opacity=100);
  -moz-opacity: 1;
  opacity: 1;
}

div.fs1_" . $ytid . "-" . $rz . " {
  width:" . $fswidth . ";
  height:" . $fsheight . ";
  float:" . $floatoben . ";
  background-image:url('" . $fsl . "');
  background-repeat: " . $bgrep . ";
  background-size: contain;
}

div.fs2_" . $ytid . "-" . $rz . " {
  width:" . $fswidth . ";
  height:" . $fsheight . ";
  float:" . $floatunten . ";
  background-image:url('" . $fsr . "');
  background-repeat: " . $bgrep . ";
  background-size: contain;
}

</style>

<!-- Struktur des Videoelements -->

<div class='ppic_" . $ytid . "-" . $rz . "'>
  <div class='ppr'>
    <a " . $param . " title='" . $tit . "' href='" . $vlink . $size . "&fs=1&feature=player_embedded'>
    <div class='fs1_" . $ytid . "-" . $rz . "'>
    </div>
    <div class='pic_" . $ytid . "-" . $rz . "'>
        <img class='pic_" . $ytid . "-" . $rz . "' src='" . $overlayimg . "' />
    </div>
    <div class='fs2_" . $ytid . "-" . $rz . "'>
    </div>
    </a>
  </div>
  <div class='title_" . $ytid . "-" . $rz . "'>
    <h5>" . $tit . "</h5>
  </div>
</div>";


  return $output;
	
}

add_shortcode('ytcode', 'ytlink_func');

register_activation_hook(__FILE__, 'activate_ytlink');
register_deactivation_hook(__FILE__, 'deactive_ytlink');

?>